//
//  Delegate.m
//  Pythagoras
//
//  Created by NYU User on 11/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Delegate.h"
#import "View.h"


@implementation Delegate

- (id) initWithView: (View *) v {
	if ((self = [super init]) != nil) {
		view = v;
	}
	return self;
}

- (void) drawLayer: (CALayer *) layer inContext: (CGContextRef) c {
	CGRect b = view.bounds;
	CGFloat r = b.size.width / 4;
	
	const CGFloat theta2 = view.theta / 2;
	const CGFloat left = 2 * r * cosf(theta2);	//length of side of left little square
	const CGFloat right = 2 * r * sinf(theta2);	//length of side of right little square
	
	//origin in center of view
	CGContextTranslateCTM(c, b.size.width / 2, b.size.height / 2);
	
	//Y axis points up
	CGContextScaleCTM(c, 1, -1);
	
	CGContextBeginPath(c);
	CGContextMoveToPoint(c, r, 0);
	
	//Three of the vertices of the right little square
	//(going counterclockwise):
	
	CGContextAddLineToPoint(c,
		r + right * cosf(theta2),
		right * sin(theta2)
	);
	
	CGContextAddLineToPoint(c,
		-r + (left + right) * cosf(theta2),
		(left + right) * sinf(theta2)
	);
	
	CGContextAddLineToPoint(c,
		-r + (left + right) * cosf(theta2),
		(left + right) * sinf(theta2)
	);
	
	//Three of the vertices of the left little square
	//(going clockwise):
	
	CGContextAddLineToPoint(c, -r, 0.0f);
	
	CGContextAddLineToPoint(c,
		-r - left * cosf(M_PI/2 - theta2),
		left * sinf(M_PI/2 - theta2)
	);
	
	CGContextAddLineToPoint(c,
		r - (left + right) * cos(M_PI/2 - theta2),
		(left + right) * sinf(M_PI/2 - theta2)
	);
	
	CGContextClosePath(c);
	CGContextSetRGBStrokeColor(c, 1.0, 1.0, 1.0, 1.0);
	CGContextStrokePath(c);	
}


@end
