//
//  View.m
//  Pythagoras
//
//  Created by NYU User on 11/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"
#import "Delegate.h"


@implementation View
@synthesize theta;


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		self.backgroundColor = [UIColor blueColor];
		theta = M_PI / 2;

		//This view is born with one layer.  Add another.
		layer = [[CALayer alloc] init];
		layer.frame = self.bounds;	//same size as the view
		layer.delegate = [[Delegate alloc] initWithView: self];
		[self.layer addSublayer: layer];
		[layer setNeedsDisplay]; //trigger a call to drawLayer:inContext:
	}
	return self;
}

- (void) touchesMoved: (NSSet *) touches withEvent: (UIEvent *) event {
	CGPoint location = [[touches anyObject] locationInView: self];
	CGPoint previous = [[touches anyObject] previousLocationInView: self];
	
	CGFloat dx = location.x - previous.x;
	theta -= dx / 50;
	
	//Keep theta in the range 0 to 180 degrees inclusive.
	
	if (theta < 0) {
		theta = 0;
	}
	
	if (theta > M_PI) {
		theta = M_PI;
	}
	
	[layer setNeedsDisplay];	//trigger a call to drawLayer:inContext:
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
	// Drawing code
	NSLog(@"drawRect:");
	
	CGRect b = self.bounds;
	CGFloat r = b.size.width / 4;
	CGContextRef c = UIGraphicsGetCurrentContext();
	
	//origin in center of view
	CGContextTranslateCTM(c, b.size.width / 2, b.size.height / 2);
	
	//Y axis points up
	CGContextScaleCTM(c, 1, -1);
	
	CGContextBeginPath(c);

	CGRect square = CGRectMake(
		-r,
		-b.size.width / 2,
		b.size.width / 2,
		b.size.width / 2
	);
	
	CGContextAddRect(c, square);
	CGContextMoveToPoint(c, r, 0);
 
	CGContextAddArc(c,
		0, 0, //center of semicircle
		b.size.width / 4,	//radius
		0, M_PI,
		0		//counterclockwise
	);

	CGContextSetRGBStrokeColor(c, 1.0, 1.0, 1.0, 1.0);
	CGContextStrokePath(c);
}


- (void) dealloc {
	[super dealloc];
}


@end
